package com.elephant.framework.galaxy.aroad.module.zhtj.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.module.zhtj.entity.ZhtjGljbxxGlzbdb;
import com.elephant.framework.galaxy.aroad.module.zhtj.service.ZhtjGljbxxGlzbdbService;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;


/**
 * 公路指标对比表
 *
 * @author xuzhitu
 * @date 2019-03-12 17:08:49
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhtj/zhtjgljbxxglzbdb")
public class ZhtjGljbxxGlzbdbController extends BaseController  {

  private final ZhtjGljbxxGlzbdbService zhtjGljbxxGlzbdbService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhtjGljbxxGlzbdb 公路指标对比表
   * @return
   */
  @GetMapping("/page")
  public R getZhtjGljbxxGlzbdbPage(Page page, ZhtjGljbxxGlzbdb zhtjGljbxxGlzbdb) {
    if(zhtjGljbxxGlzbdb.getYear() == null){
      zhtjGljbxxGlzbdb.setYear("2018");
    }
    return  new R<>(zhtjGljbxxGlzbdbService.page(page,Wrappers.query(zhtjGljbxxGlzbdb)));
  }


  /**
   * 通过id查询公路指标对比表
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") Integer id){
    return new R<>(zhtjGljbxxGlzbdbService.getById(id));
  }

  /**
   * 新增公路指标对比表
   * @param zhtjGljbxxGlzbdb 公路指标对比表
   * @return R
   */
  @SysLog("新增公路指标对比表")
  @PostMapping
  public R save(@RequestBody ZhtjGljbxxGlzbdb zhtjGljbxxGlzbdb){
    return new R<>(zhtjGljbxxGlzbdbService.save(zhtjGljbxxGlzbdb));
  }

  /**
   * 修改公路指标对比表
   * @param zhtjGljbxxGlzbdb 公路指标对比表
   * @return R
   */
  @SysLog("修改公路指标对比表")
  @PutMapping
  public R updateById(@RequestBody ZhtjGljbxxGlzbdb zhtjGljbxxGlzbdb){
    return new R<>(zhtjGljbxxGlzbdbService.updateById(zhtjGljbxxGlzbdb));
  }

  /**
   * 通过id删除公路指标对比表
   * @param id id
   * @return R
   */
  @SysLog("删除公路指标对比表")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable Integer id){
    return new R<>(zhtjGljbxxGlzbdbService.removeById(id));
  }

}
